#include "iv.h"
#include "prng.h"

Iv::Iv()
{
}

QString Iv::GetIvs(unsigned long int pidin, QProgressBar* prog)
{
        QString nats[25]={"Hardy","Lonely","Brave","Adamant","Naughty","Bold","Docile","Relaxed","Impish","Lax","Timid","Hasty","Serious","Jolly","Naive","Modest","Mild","Quiet","Bashful","Rash","Calm","Gentle","Sassy","Careful","Quirky"};
        QString hptype[16]={ "Fighting", "Flying", "Poison", "Ground", "Rock", "Bug", "Ghost", "Steel", "Fire", "Water", "Grass", "Electric", "Psychic", "Ice", "Dragon", "Dark" };
        QString output = "";


        this->pid=pidin;

        this->numFound=0;

        unsigned int high=pidin&0xffff0000;
        int low = pidin&0xffff;

        Prng prng;
        for(int i=0;i<=0xffff ;i++)
        {
                int c,d,e,f;
                unsigned int s=high +i;
                prng.SetSeed(s);
                if((prng.Prev()>>0x10)==low)
                {
                        Prng prng8;
                        prng8.SetSeed(prng.Prev());
                        //output += QString::number( prng8.Prev() ) + "\n\n";

                        //cout<<"\n\n"<<hex<<prng8.Prev()<<"\n";
                        c=((int)(prng.Next()>>0x10))&0x7fff;
                        prng.SetNext();
                        d=((int)(prng.Next()>>0x10))&0x7fff;
                        prng.SetNext();
                        e=((int)(prng.Next()>>0x10))&0x7fff;
                        prng.SetNext();
                        f=((int)(prng.Next()>>0x10))&0x7fff;

                        this->numFound+=1;

                        this->ivs[0]=c&0x1f;
                        this->ivs[1]=(c&0x3e0)>>5;
                        this->ivs[2]=(c&0x7c00)>>10;
                        this->ivs[3]=d&0x1f;
                        this->ivs[4]=(d&0x3e0)>>5;
                        this->ivs[5]=(d&0x7c00)>>10;

                        output += "--------------------------------------------------------------\n";
                        output += QString::number( this->numFound ) + ") Normal D/P or GBA\n";
                        output += "Nature : " + nats[ this->pid%25 ] + "\n";
                        output += "IVs (SpD last) : " + QString::number( ivs[0] ) + " / " + QString::number( ivs[1] ) + " / " + QString::number( ivs[2] ) + " / " + QString::number( ivs[3] ) + " / " + QString::number( ivs[4] ) + " / " + QString::number( ivs[5] ) + "\n";
                        output += "Ability : " + QString::number( 2-((this->pid)%2) ) + "\n";
                        output += "Gender Value : " + QString::number( this->pid%256 ) + "\n";
                        output += "Hidden Power : " + hptype[ this->HPType() ] + " - " + QString::number( this->HPPower() ) + "\n";


                        /* cout<<"\n\n--------------------------------------------------------------\n\n";
                        cout<<this->numFound<<") Normal D/P or GBA\n";
                        cout<<"IVs/Nature: "<<ivs[0]<<"/"<<ivs[1]<<"/"<<ivs[2]<<"/"<<ivs[3]<<"/"<<ivs[4]<<"/"<<ivs[5]<<"/"<<nats[this->pid%25]<<endl;
                        cout<<"Ability : "<<2-((this->pid)%2)<<endl;
                        cout<<"Gender Value: "<<this->pid%256<<endl;
                        cout<<"Hidden Power: "<<hptype[this->HPType()]<<"-"<<this->HPPower()<<endl; */

                        this->numFound+=1;

                        this->ivs[0]=d&0x1f;
                        this->ivs[1]=(d&0x3e0)>>5;
                        this->ivs[2]=(d&0x7c00)>>10;
                        this->ivs[3]=e&0x1f;
                        this->ivs[4]=(e&0x3e0)>>5;
                        this->ivs[5]=(e&0x7c00)>>10;

                        output += "--------------------------------------------------------------\n";
                        output += QString::number( this->numFound ) + ") Non-event D/P or GBA\n";
                        output += "Nature : " + nats[ this->pid%25 ] + "\n";
                        output += "IVs (SpD last) : " + QString::number( ivs[0] ) + " / " + QString::number( ivs[1] ) + " / " + QString::number( ivs[2] ) + " / " + QString::number( ivs[3] ) + " / " + QString::number( ivs[4] ) + " / " + QString::number( ivs[5] ) + "\n";
                        output += "Ability : " + QString::number( 2-((this->pid)%2) ) + "\n";
                        output += "Gender Value : " + QString::number( this->pid%256 ) + "\n";
                        output += "Hidden Power : " + hptype[ this->HPType() ] + " - " + QString::number( this->HPPower() ) + "\n";

                        /* cout<<"\n\n--------------------------------------------------------------\n\n";
                        cout<<this->numFound<<") Non-Event D/P or GBA\n";
                        cout<<"IVs/Nature: "<<ivs[0]<<"/"<<ivs[1]<<"/"<<ivs[2]<<"/"<<ivs[3]<<"/"<<ivs[4]<<"/"<<ivs[5]<<"/"<<nats[this->pid%25]<<endl;
                        cout<<"Ability : "<<2-((this->pid)%2)<<endl;
                        cout<<"Gender Value: "<<this->pid%256<<endl;
                        cout<<"Hidden Power: "<<hptype[this->HPType()]<<"-"<<this->HPPower()<<endl; */

                        this->numFound+=1;

                        this->ivs[0]=c&0x1f;
                        this->ivs[1]=(c&0x3e0)>>5;
                        this->ivs[2]=(c&0x7c00)>>10;
                        this->ivs[3]=e&0x1f;
                        this->ivs[4]=(e&0x3e0)>>5;
                        this->ivs[5]=(e&0x7c00)>>10;

                        output += "--------------------------------------------------------------\n";
                        output += QString::number( this->numFound ) + ") Normal GBA\n";
                        output += "Nature : " + nats[ this->pid%25 ] + "\n";
                        output += "IVs (SpD last) : " + QString::number( ivs[0] ) + " / " + QString::number( ivs[1] ) + " / " + QString::number( ivs[2] ) + " / " + QString::number( ivs[3] ) + " / " + QString::number( ivs[4] ) + " / " + QString::number( ivs[5] ) + "\n";
                        output += "Ability : " + QString::number( 2-((this->pid)%2) ) + "\n";
                        output += "Gender Value : " + QString::number( this->pid%256 ) + "\n";
                        output += "Hidden Power : " + hptype[ this->HPType() ] + " - " + QString::number( this->HPPower() ) + "\n";

                        /* cout<<"\n\n--------------------------------------------------------------\n\n";
                        cout<<this->numFound<<") Normal GBA\n";
                        cout<<"IVs/Nature: "<<ivs[0]<<"/"<<ivs[1]<<"/"<<ivs[2]<<"/"<<ivs[3]<<"/"<<ivs[4]<<"/"<<ivs[5]<<"/"<<nats[this->pid%25]<<endl;
                        cout<<"Ability : "<<2-((this->pid)%2)<<endl;
                        cout<<"Gender Value: "<<this->pid%256<<endl;
                        cout<<"Hidden Power: "<<hptype[this->HPType()]<<"-"<<this->HPPower()<<endl; */

                        this->numFound+=1;

                        this->ivs[0]=d&0x1f;
                        this->ivs[1]=(d&0x3e0)>>5;
                        this->ivs[2]=(d&0x7c00)>>10;
                        this->ivs[3]=f&0x1f;
                        this->ivs[4]=(f&0x3e0)>>5;
                        this->ivs[5]=(f&0x7c00)>>10;

                        output += "--------------------------------------------------------------\n";
                        output += QString::number( this->numFound ) + ") Rare GBA\n";
                        output += "Nature : " + nats[ this->pid%25 ] + "\n";
                        output += "IVs (SpD last) : " + QString::number( ivs[0] ) + " / " + QString::number( ivs[1] ) + " / " + QString::number( ivs[2] ) + " / " + QString::number( ivs[3] ) + " / " + QString::number( ivs[4] ) + " / " + QString::number( ivs[5] ) + "\n";
                        output += "Ability : " + QString::number( 2-((this->pid)%2) ) + "\n";
                        output += "Gender Value : " + QString::number( this->pid%256 ) + "\n";
                        output += "Hidden Power : " + hptype[ this->HPType() ] + " - " + QString::number( this->HPPower() ) + "\n";

                        /* cout<<"\n\n--------------------------------------------------------------\n\n";
                        cout<<this->numFound<<") Rare GBA\n";
                        cout<<"IVs/Nature: "<<ivs[0]<<"/"<<ivs[1]<<"/"<<ivs[2]<<"/"<<ivs[3]<<"/"<<ivs[4]<<"/"<<ivs[5]<<"/"<<nats[this->pid%25]<<endl;
                        cout<<"Ability : "<<2-((this->pid)%2)<<endl;
                        cout<<"Gender Value: "<<this->pid%256<<endl;
                        cout<<"Hidden Power: "<<hptype[this->HPType()]<<"-"<<this->HPPower()<<endl; */

                        this->numFound+=1;

                        this->ivs[0]=e&0x1f;
                        this->ivs[1]=(e&0x3e0)>>5;
                        this->ivs[2]=(e&0x7c00)>>10;
                        this->ivs[3]=f&0x1f;
                        this->ivs[4]=(f&0x3e0)>>5;
                        this->ivs[5]=(f&0x7c00)>>10;

                        output += "--------------------------------------------------------------\n";
                        output += QString::number( this->numFound ) + ") Rare GBA\n";
                        output += "Nature : " + nats[ this->pid%25 ] + "\n";
                        output += "IVs (SpD last) : " + QString::number( ivs[0] ) + " / " + QString::number( ivs[1] ) + " / " + QString::number( ivs[2] ) + " / " + QString::number( ivs[3] ) + " / " + QString::number( ivs[4] ) + " / " + QString::number( ivs[5] ) + "\n";
                        output += "Ability : " + QString::number( 2-((this->pid)%2) ) + "\n";
                        output += "Gender Value : " + QString::number( this->pid%256 ) + "\n";
                        output += "Hidden Power : " + hptype[ this->HPType() ] + " - " + QString::number( this->HPPower() ) + "\n";

                        /* cout<<"\n\n--------------------------------------------------------------\n\n";
                        cout<<this->numFound<<") Ultra-Rare GBA\n";
                        cout<<"IVs/Nature: "<<ivs[0]<<"/"<<ivs[1]<<"/"<<ivs[2]<<"/"<<ivs[3]<<"/"<<ivs[4]<<"/"<<ivs[5]<<"/"<<nats[this->pid%25]<<endl;
                        cout<<"Ability : "<<2-((this->pid)%2)<<endl;
                        cout<<"Gender Value: "<<this->pid%256<<endl;
                        cout<<"Hidden Power: "<<hptype[this->HPType()]<<"-"<<this->HPPower()<<endl; */
                }
                prog->setValue( prog->value()+1 );
        }

        if((this->numFound==0))
        {
            output = "Sorry, could not find IVs for this PID.";

                /* cout<<"\n\n--------------------------------------------------------------\n\n";
                cout<<"Sorry, cound not find a PID for those IVs and Nature";
                cout<<"\n\n--------------------------------------------------------------\n\n"; */
        }
    return output;
}

int Iv::HPPower()
{
     int num = 0;
     for (int i = 0; i < 6; i++)
     {
         if ((this->ivs[i] % 4) > 1)
         {
             num += (int) pow(2.0, (double) i);
         }
     }
     return (((num * 40) / 0x3f) + 30);


}
int Iv::HPType()
{
 int num = 0;
            for (int i = 0; i < 6; i++)
            {
                if ((this->ivs[i] % 2) == 1)
                {
                    num += (int) pow(2.0, i);
                }
            }
            return ((num * 15) / 0x3f);
}
