#include "pid.h"
#include "prng.h"
#include "pidiv.h"

Pid::Pid()
{
}

QString Pid::Wild(unsigned int nat, unsigned int hp, unsigned int att, unsigned int def, unsigned int spe, unsigned int spa, unsigned int spd, QProgressBar* prog)
{
    QString output = "";

    QString nats[25]={"Hardy","Lonely","Brave","Adamant","Naughty","Bold","Docile","Relaxed","Impish","Lax","Timid","Hasty","Serious","Jolly","Naive","Modest","Mild","Quiet","Bashful","Rash","Calm","Gentle","Sassy","Careful","Quirky"};
    QString hptype[16]={ "Fighting", "Flying", "Poison", "Ground", "Rock", "Bug", "Ghost", "Steel", "Fire", "Water", "Grass", "Electric", "Psychic", "Ice", "Dragon", "Dark" };
        this->numFound=0;
        this->in[0] = hp;
        this->in[1] = att;
        this->in[2] = def;
        this->in[3] = spe;
        this->in[4] = spa;
        this->in[5] = spd;
        this->in[6] = nat;
        this->ivs=(this->in[0]+(this->in[1]<<5)+(this->in[2]<<10)+(this->in[3]<<15)+(this->in[4]<<20)+(this->in[5]<<25))&0x7fffffff;
        this->iv1=(int)(((this->ivs)&0xffff)%0x8000);
        this->iv2=(int)((this->ivs)>>0xf);

        for(int i=0;i<=0xffff;i++)
        {
                if((i&0x7fff)==(this->iv2))
                {

                        for(int j=0;j<=0xffff;j++)
                        {
                                Prng prng((i<<0x10)+j);
                                prng.SetSeed(prng.Prev());
                                if(((prng.GetSeed()&0x7fff0000)>>0x10)==(this->iv1))
                                {
                                        Prng prng2(prng.Prev());

                                        this->pid=(prng2.GetSeed()&0xffff0000)+(prng2.Prev()>>0x10);
                                        Prng prng3(prng2.Prev());
                                        if(((((this->pid)%25)==(this->in[6])))||(this->in[6])==25)
                                        {
                                                (this->numFound)+=1;
                                                output = output + QString::number(numFound) ;
                                                output += ") Normal D/P or GBA: " ;
                                                output += QString::number( this->pid ) + "\n";
                                                output += "Nature : " + nats[ ((this->pid)%25) ] + "\n" ;
                                                output += "Ability : " + QString::number(2-((this->pid)%2)) + "\n" ;
                                                output += "Gender Value : " + QString::number(((this->pid)%256)) + "\n" ;
                                                output += "Hidden Power : " + hptype[ this->HPType() ] + " - " + QString::number( this->HPPower() ) + "\n" ;
                                                output += "Shiny TID/SID : " + QString::number(((this->pid) & 0xFFFF)) + ", " + QString::number( ((this->pid) >> 0x10) ) + "\n" ;
                                                output += "--------------------------------------------------------------\n" ;


                                                //The next lines are from the old program.
                                                /*cout<<numFound<<") Normal D/P or GBA: "<<this->pid<<endl;
                                                cout<<"Nature :"<<nats[(this->pid%25)]<<endl;
                                                cout<<"Ability : "<<2-((this->pid)%2)<<endl;
                                                cout<<"Gender Value:"<<(this->pid%256)<<endl;
                                                cout<<"Hidden Power: "<<hptype[this->HPType()]<<"-"<<this->HPPower()<<endl;
                                                cout<<"Shiny TID/SID : "<<((this->pid)&0xFFFF)<<", "<<((this->pid)>>0x10)<<endl;
                                                cout<<"\n\n--------------------------------------------------------------\n\n";*/
                                        }
                                        prng2.SetSeed(prng2.Prev());
                                        prng3.SetSeed(prng3.Prev());
                                        this->pid=(prng2.GetSeed()&0xffff0000)+(prng2.Prev()>>0x10);
                                        if(((((this->pid%25))==(this->in[6])))||(this->in[6])==25)
                                        {
                                                (this->numFound)+=1;
                                                output = output + QString::number(numFound) ;
                                                output += ") Non-event D/P or GBA: " ;
                                                output += QString::number( this->pid ) + "\n";
                                                output += "Nature : " + nats[ ((this->pid)%25) ] + "\n" ;
                                                output += "Ability : " + QString::number(2-((this->pid)%2)) + "\n" ;
                                                output += "Gender Value : " + QString::number(((this->pid)%256)) + "\n" ;
                                                output += "Hidden Power : " + hptype[ this->HPType() ] + " - " + QString::number( this->HPPower() ) + "\n" ;
                                                output += "Shiny TID/SID : " + QString::number(((this->pid) & 0xFFFF)) + ", " + QString::number( ((this->pid) >> 0x10) ) + "\n" ;
                                                output += "--------------------------------------------------------------\n" ;

                                                /* cout<<numFound<<") Non-event D/P or GBA: "<<this->pid<<endl;
                                                cout<<"Nature :"<<nats[(this->pid%25)]<<endl;
                                                cout<<"Ability : "<<2-((this->pid)%2)<<endl;
                                                cout<<"Gender Value:"<<(this->pid%256)<<endl;
                                                cout<<"Hidden Power: "<<hptype[this->HPType()]<<"-"<<this->HPPower()<<endl;
                                                cout<<"Shiny TID/SID : "<<((this->pid)&0xFFFF)<<", "<<((this->pid)>>0x10)<<endl;
                                                cout<<"\n\n--------------------------------------------------------------\n\n"; */
                                        }
                                        prng2.SetSeed(prng2.Prev());
                                        this->pid=(prng2.GetSeed()&0xffff0000)+(prng2.Prev()>>0x10);
                                        if(((((this->pid%25))==(this->in[6])))||(this->in[6])==25)
                                        {
                                                (this->numFound)+=1;
                                                output = output + QString::number(numFound) ;
                                                output += ") Ultra-rare GBA: " ;
                                                output += QString::number( this->pid ) + "\n";
                                                output += "Nature : " + nats[ ((this->pid)%25) ] + "\n" ;
                                                output += "Ability : " + QString::number(2-((this->pid)%2)) + "\n" ;
                                                output += "Gender Value : " + QString::number(((this->pid)%256)) + "\n" ;
                                                output += "Hidden Power : " + hptype[ this->HPType() ] + " - " + QString::number( this->HPPower() ) + "\n" ;
                                                output += "Shiny TID/SID : " + QString::number(((this->pid) & 0xFFFF)) + ", " + QString::number( ((this->pid) >> 0x10) ) + "\n" ;
                                                output += "--------------------------------------------------------------\n" ;

                                                /* cout<<numFound<<") Utra-rare GBA: "<<this->pid<<endl;
                                                cout<<"Nature :"<<nats[(this->pid%25)]<<endl;
                                                cout<<"Ability : "<<2-((this->pid)%2)<<endl;
                                                cout<<"Gender Value:"<<(this->pid%256)<<endl;
                                                cout<<"Hidden Power: "<<hptype[this->HPType()]<<"-"<<this->HPPower()<<endl;
                                                cout<<"Shiny TID/SID : "<<((this->pid)&0xFFFF)<<", "<<((this->pid)>>0x10)<<endl;
                                                cout<<"\n\n--------------------------------------------------------------\n\n"; */

                                        }
                                }
                                prng.SetSeed(prng.Prev());
                                if(((prng.GetSeed()&0x7fff0000)>>0x10)==(this->iv1))
                                {

                                        prng.SetSeed(prng.Prev());
                                        this->pid=(prng.GetSeed()&0xffff0000)+(prng.Prev()>>0x10);
                                        if(((((this->pid)%25)==(this->in[6])))||(this->in[6])==25)
                                        {
                                                (this->numFound)+=1;
                                                output = output + QString::number(numFound) ;
                                                output += ") Normal GBA: " ;
                                                output += QString::number( this->pid ) + "\n";
                                                output += "Nature : " + nats[ ((this->pid)%25) ] + "\n" ;
                                                output += "Ability : " + QString::number(2-((this->pid)%2)) + "\n" ;
                                                output += "Gender Value : " + QString::number(((this->pid)%256)) + "\n" ;
                                                output += "Hidden Power : " + hptype[ this->HPType() ] + " - " + QString::number( this->HPPower() ) + "\n" ;
                                                output += "Shiny TID/SID : " + QString::number(((this->pid) & 0xFFFF)) + ", " + QString::number( ((this->pid) >> 0x10) ) + "\n" ;
                                                output += "--------------------------------------------------------------\n" ;

                                                /* cout<<numFound<<") Normal GBA: "<<this->pid<<endl;
                                                cout<<"Nature : "<<nats[((this->pid)%25)]<<endl;
                                                cout<<"Ability : "<<2-((this->pid)%2)<<endl;
                                                cout<<"Gender Value:"<<(this->pid%256)<<endl;
                                                cout<<"Hidden Power: "<<hptype[this->HPType()]<<"-"<<this->HPPower()<<endl;
                                                cout<<"Shiny TID/SID : "<<((this->pid)&0xFFFF)<<", "<<((this->pid)>>0x10)<<endl;
                                                cout<<"\n\n--------------------------------------------------------------\n\n"; */
                                        }
                                        prng.SetSeed(prng.Prev());
                                        this->pid=(prng.GetSeed()&0xffff0000)+(prng.Prev()>>0x10);
                                        if(((((this->pid)%25)==(this->in[6])))||(this->in[6])==25)
                                        {
                                                (this->numFound)+=1;
                                                output = output + QString::number(numFound) ;
                                                output += ") Rare GBA: " ;
                                                output += QString::number( this->pid ) + "\n";
                                                output += "Nature : " + nats[ ((this->pid)%25) ] + "\n" ;
                                                output += "Ability : " + QString::number(2-((this->pid)%2)) + "\n" ;
                                                output += "Gender Value : " + QString::number(((this->pid)%256)) + "\n" ;
                                                output += "Hidden Power : " + hptype[ this->HPType() ] + " - " + QString::number( this->HPPower() ) + "\n" ;
                                                output += "Shiny TID/SID : " + QString::number(((this->pid) & 0xFFFF)) + ", " + QString::number( ((this->pid) >> 0x10) ) + "\n" ;
                                                output += "--------------------------------------------------------------\n" ;

                                                /* cout<<numFound<<") Rare GBA: "<<this->pid<<endl;
                                                cout<<"Nature :"<<nats[((this->pid)%25)]<<endl;
                                                cout<<"Ability : "<<2-((this->pid)%2)<<endl;
                                                cout<<"Gender Value:"<<(this->pid%256)<<endl;
                                                cout<<"Hidden Power: "<<hptype[this->HPType()]<<"-"<<this->HPPower()<<endl;
                                                cout<<"Shiny TID/SID : "<<((this->pid)&0xFFFF)<<", "<<((this->pid)>>0x10)<<endl;
                                                cout<<"\n\n--------------------------------------------------------------\n\n"; */
                                        }
                                }
                        }
                }
                prog->setValue( prog->value()+1 );
        }
        if((this->numFound==0))
        {
            output = "Sorry, could not find a PID for those IVs and Nature.";

            /* cout<<"\n\n--------------------------------------------------------------\n\n";
            cout<<"Sorry, cound not find a PID for those IVs and Nature";
            cout<<"\n\n--------------------------------------------------------------\n\n"; */
        }
        return output;
}

int Pid::HPPower()
{
     int num = 0;
     for (int i = 0; i < 6; i++)
     {
         if ((this->in[i] % 4) > 1)
         {
             num += (int) pow(2.0, (double)i);
         }
     }
     return (((num * 40) / 0x3f) + 30);


}
int Pid::HPType()
{
 int num = 0;
            for (int i = 0; i < 6; i++)
            {
                if ((this->in[i] % 2) == 1)
                {
                    num += (int) pow(2.0, (double)i);
                }
            }
            return ((num * 15) / 0x3f);
}
