#include "pidiv.h"
#include "ui_pidiv.h"
#include "pid.h"
#include "iv.h"
#include "shinypid.h"

PIDIV::PIDIV(QWidget *parent)
    : QMainWindow(parent), ui(new Ui::PIDIV)
{
    ui->setupUi(this);
    ui->Op1->setChecked(true);
    ui->Nature->addItem("Hardy");
    ui->Nature->addItem("Lonely");
    ui->Nature->addItem("Brave");
    ui->Nature->addItem("Adamant");
    ui->Nature->addItem("Naughty");
    ui->Nature->addItem("Bold");
    ui->Nature->addItem("Docile");
    ui->Nature->addItem("Relaxed");
    ui->Nature->addItem("Impish");
    ui->Nature->addItem("Lax");
    ui->Nature->addItem("Timid");
    ui->Nature->addItem("Hasty");
    ui->Nature->addItem("Serious");
    ui->Nature->addItem("Jolly");
    ui->Nature->addItem("Naive");
    ui->Nature->addItem("Modest");
    ui->Nature->addItem("Mild");
    ui->Nature->addItem("Quiet");
    ui->Nature->addItem("Bashful");
    ui->Nature->addItem("Rash");
    ui->Nature->addItem("Calm");
    ui->Nature->addItem("Gentle");
    ui->Nature->addItem("Sassy");
    ui->Nature->addItem("Careful");
    ui->Nature->addItem("Quirky");
    ui->Nature->addItem("Any Nature");
    ui->Nature->setCurrentIndex( 25 );
}

PIDIV::~PIDIV()
{
    delete ui;
}

void PIDIV::updateWidgets()
{
    ui->Nature->setEnabled(true);
    ui->HP->setEnabled(true);
    ui->Att->setEnabled(true);
    ui->Def->setEnabled(true);
    ui->SpA->setEnabled(true);
    ui->SpD->setEnabled(true);
    ui->Spe->setEnabled(true);
    ui->PID->setEnabled(true);
    ui->ID->setEnabled(true);
    ui->SID->setEnabled(true);
    ui->limit->setEnabled(true);

    if (ui->Op1->isChecked() == true)
    {
        ui->SID->setEnabled(false);
        ui->ID->setEnabled(false);
        ui->PID->setEnabled(false);
        ui->limit->setEnabled(false);
    }
    if (ui->Op2->isChecked() == true)
    {
        ui->PID->setEnabled(false);
    }
    if (ui->Op3->isChecked() == true)
    {
        ui->PID->setEnabled(false);
    }
    if (ui->Op4->isChecked() == true)
    {
        ui->PID->setEnabled(false);
        ui->limit->setEnabled(false);
    }
    if (ui->Op5->isChecked() == true)
    {
        ui->Nature->setEnabled(false);
        ui->ID->setEnabled(false);
        ui->SID->setEnabled(false);
        ui->HP->setEnabled(false);
        ui->Att->setEnabled(false);
        ui->Def->setEnabled(false);
        ui->SpA->setEnabled(false);
        ui->SpD->setEnabled(false);
        ui->Spe->setEnabled(false);
        ui->limit->setEnabled(false);
    }
}

void PIDIV::RunCalculation()
{
    if ( ui->Op5->isChecked() == false && Validate() == false )
    {
        ui->Output->setPlainText("One of the IV or ID values is not valid. Please fix the problem and try again.");
        return;
    }
    if (ui->Op1->isChecked() == true)
    {
        ui->progressBar->setValue(0);
        ui->progressBar->setMaximum(0xffff);
        Pid getPid;
        ui->Output->setPlainText( getPid.Wild( ui->Nature->currentIndex(), ui->HP->text().toUShort(), ui->Att->text().toUShort(), ui->Def->text().toUShort(), ui->Spe->text().toUShort(), ui->SpA->text().toUShort(), ui->SpD->text().toUShort(), ui->progressBar ) );
        return;
    }
    if (ui->Op2->isChecked() == true)
    {
        ui->progressBar->setValue(0);
        ui->progressBar->setMaximum(0xffff);
        ShinyPid getPid;
        ui->Output->setPlainText( getPid.GetPidIVs( ui->Nature->currentIndex(), ui->SID->text().toUShort(), ui->ID->text().toUShort(), ui->HP->text().toUShort(), ui->Att->text().toUShort(), ui->Def->text().toUShort(), ui->Spe->text().toUShort(), ui->SpA->text().toUShort(), ui->SpD->text().toUShort(), false, ui->limit->text().toUShort() ,ui->progressBar ) );
        return;
    }
    if (ui->Op3->isChecked() == true)
    {
        ui->progressBar->setValue(0);
        ui->progressBar->setMaximum(0xffff);
        ShinyPid getPid;
        ui->Output->setPlainText( getPid.GetPidIVs( ui->Nature->currentIndex(), ui->SID->text().toUShort(), ui->ID->text().toUShort(), ui->HP->text().toUShort(), ui->Att->text().toUShort(), ui->Def->text().toUShort(), ui->Spe->text().toUShort(), ui->SpA->text().toUShort(), ui->SpD->text().toUShort(), true, ui->limit->text().toUShort() ,ui->progressBar ) );
        return;
    }
    if (ui->Op4->isChecked() == true)
    {
        ui->progressBar->setValue(0);
        ui->progressBar->setMaximum(0xffff);
        ShinyPid getPid;
        ui->Output->setPlainText( getPid.GetChainedPid( ui->Nature->currentIndex(), ui->SID->text().toUShort(), ui->ID->text().toUShort(), ui->HP->text().toUShort(), ui->Att->text().toUShort(), ui->Def->text().toUShort(), ui->Spe->text().toUShort(), ui->SpA->text().toUShort(), ui->SpD->text().toUShort() ,ui->progressBar ) );
        return;
    }
    if (ui->Op5->isChecked() == true)
    {
        ui->progressBar->setValue(0);
        ui->progressBar->setMaximum(0xffff);
        Iv getIvs;
        ui->Output->setPlainText( getIvs.GetIvs( ui->PID->text().toULong() , ui->progressBar ) );
        return;
    }
}

QString PIDIV::func4()
{
    return "4";
}


bool PIDIV::Validate()
{
    bool valid = true;
    unsigned short int hp = ui->HP->text().toUShort();
    unsigned short int att = ui->Att->text().toUShort();
    unsigned short int def = ui->Def->text().toUShort();
    unsigned short int spa = ui->SpA->text().toUShort();
    unsigned short int spd = ui->SpD->text().toUShort();
    unsigned short int spe = ui->Spe->text().toUShort();
    unsigned long int sid = ui->SID->text().toUShort();
    unsigned long int tid = ui->ID->text().toUShort();
    if ( hp>31 || att>31 || def>31 || spa>31 || spd>31 || spe>31 || sid>65535 || tid>65535 )
    {
        valid = false;
    }
    return valid;
}
