#include "shinypid.h"

ShinyPid::ShinyPid()
{
}

QString ShinyPid::GetPidIVs(unsigned short int nature, unsigned short int sid, unsigned short int tid, unsigned int hp, unsigned int att, unsigned int def, unsigned int spe, unsigned int spa, unsigned int spd, bool strict, int limit, QProgressBar* prog)
{
    QString output = "";
     this->Strict=strict;
     this->Limit=limit;

        this->numFound=0;
        this->in[0] = hp;
        this->in[1] = att;
        this->in[2] = def;
        this->in[3] = spe;
        this->in[4] = spa;
        this->in[5] = spd;
        this->in[6] = nature;
        this->ids[0] = sid;
        this->ids[1] = tid;

        //GetData();
        int xo=ids[0]^ids[1];

        for(int i=0;i<=0xffff;i++)
        {
                this->low=i;
                int h=((i^xo)>>3)<<3;
                int l=(i^xo)&0x7;

                if(l==0)
                {
                        this->high=h+0;
                        output += PidIVs(this->high,this->low);
                        this->high=h+1;
                        output += PidIVs(this->high,this->low);
                        this->high=h+2;
                        output += PidIVs(this->high,this->low);
                        this->high=h+3;
                        output += PidIVs(this->high,this->low);
                        this->high=h+4;
                        output += PidIVs(this->high,this->low);
                        this->high=h+5;
                        output += PidIVs(this->high,this->low);
                        this->high=h+6;
                        output += PidIVs(this->high,this->low);
                        this->high=h+7;
                        output += PidIVs(this->high,this->low);
                }
                else if(l==1)
                {
                        this->high=h+1;
                        output += PidIVs(this->high,this->low);
                        this->high=h+0;
                        output += PidIVs(this->high,this->low);
                        this->high=h+3;
                        output += PidIVs(this->high,this->low);
                        this->high=h+2;
                        output += PidIVs(this->high,this->low);
                        this->high=h+5;
                        output += PidIVs(this->high,this->low);
                        this->high=h+4;
                        output += PidIVs(this->high,this->low);
                        this->high=h+7;
                        output += PidIVs(this->high,this->low);
                        this->high=h+6;
                        output += PidIVs(this->high,this->low);
                }
                else if(l==2)
                {
                        this->high=h+2;
                        output += PidIVs(this->high,this->low);
                        this->high=h+3;
                        output += PidIVs(this->high,this->low);
                        this->high=h+0;
                        output += PidIVs(this->high,this->low);
                        this->high=h+1;
                        output += PidIVs(this->high,this->low);
                        this->high=h+6;
                        output += PidIVs(this->high,this->low);
                        this->high=h+7;
                        output += PidIVs(this->high,this->low);
                        this->high=h+4;
                        output += PidIVs(this->high,this->low);
                        this->high=h+5;
                        output += PidIVs(this->high,this->low);
                }
                else if(l==3)
                {
                        this->high=h+3;
                        output += PidIVs(this->high,this->low);
                        this->high=h+2;
                        output += PidIVs(this->high,this->low);
                        this->high=h+1;
                        output += PidIVs(this->high,this->low);
                        this->high=h+0;
                        output += PidIVs(this->high,this->low);
                        this->high=h+7;
                        output += PidIVs(this->high,this->low);
                        this->high=h+6;
                        output += PidIVs(this->high,this->low);
                        this->high=h+5;
                        output += PidIVs(this->high,this->low);
                        this->high=h+4;
                        output += PidIVs(this->high,this->low);
                }
                else if(l==4)
                {
                        this->high=h+4;
                        output += PidIVs(this->high,this->low);
                        this->high=h+5;
                        output += PidIVs(this->high,this->low);
                        this->high=h+6;
                        output += PidIVs(this->high,this->low);
                        this->high=h+7;
                        output += PidIVs(this->high,this->low);
                        this->high=h+0;
                        output += PidIVs(this->high,this->low);
                        this->high=h+1;
                        output += PidIVs(this->high,this->low);
                        this->high=h+2;
                        output += PidIVs(this->high,this->low);
                        this->high=h+3;
                        output += PidIVs(this->high,this->low);
                }
                else if(l==5)
                {
                        this->high=h+5;
                        output += PidIVs(this->high,this->low);
                        this->high=h+4;
                        output += PidIVs(this->high,this->low);
                        this->high=h+7;
                        output += PidIVs(this->high,this->low);
                        this->high=h+6;
                        output += PidIVs(this->high,this->low);
                        this->high=h+1;
                        output += PidIVs(this->high,this->low);
                        this->high=h+0;
                        output += PidIVs(this->high,this->low);
                        this->high=h+3;
                        output += PidIVs(this->high,this->low);
                        this->high=h+2;
                        output += PidIVs(this->high,this->low);
                }
                else if(l==6)
                {
                        this->high=h+6;
                        output += PidIVs(this->high,this->low);
                        this->high=h+7;
                        output += PidIVs(this->high,this->low);
                        this->high=h+4;
                        output += PidIVs(this->high,this->low);
                        this->high=h+5;
                        output += PidIVs(this->high,this->low);
                        this->high=h+2;
                        output += PidIVs(this->high,this->low);
                        this->high=h+3;
                        output += PidIVs(this->high,this->low);
                        this->high=h+0;
                        output += PidIVs(this->high,this->low);
                        this->high=h+1;
                        output += PidIVs(this->high,this->low);
                }
                else if(l==7)
                {
                        this->high=h+7;
                        output += PidIVs(this->high,this->low);
                        this->high=h+6;
                        output += PidIVs(this->high,this->low);
                        this->high=h+5;
                        output += PidIVs(this->high,this->low);
                        this->high=h+4;
                        output += PidIVs(this->high,this->low);
                        this->high=h+3;
                        output += PidIVs(this->high,this->low);
                        this->high=h+2;
                        output += PidIVs(this->high,this->low);
                        this->high=h+1;
                        output += PidIVs(this->high,this->low);
                        this->high=h+0;
                        output += PidIVs(this->high,this->low);
                }

                prog->setValue( prog->value()+1 );

        }

        if((this->numFound==0))
        {
            output = "Sorry, could not find a PID for your input";

            /* cout<<"\n\n--------------------------------------------------------------\n\n";
                cout<<"Sorry, cound not find a PID for your input";
                cout<<"\n\n--------------------------------------------------------------\n\n"; */
        }


return output;

}

QString ShinyPid::PidIVs(int high, int low)
{
    QString out = "";
QString* pout = &out;
        this->pid=(high<<0x10)+low;
        Prng prng;
        for(int i=0;i<0xffff && (this->numFound<this->Limit || this->Limit==0);i++)
        {
                int c,d,e,f;
                unsigned int s=(high<<0x10) +i;
                prng.SetSeed(s);
                if((prng.Prev()>>0x10)==low)
                {
                        c=((int)(prng.Next()>>0x10))&0x7fff;
                        prng.SetNext();
                        d=((int)(prng.Next()>>0x10))&0x7fff;
                        prng.SetNext();
                        e=((int)(prng.Next()>>0x10))&0x7fff;
                        prng.SetNext();
                        f=((int)(prng.Next()>>0x10))&0x7fff;

                        if(this->Strict)
                        {
                         if( StrictCheckIVsNat(c,d,pout) )
                         {
                                out += "Normal D/P or GBA\n--------------------------------------------------------------\n";

                                //cout<<"Normal D/P or GBA\n";
                                //cout<<"\n\n--------------------------------------------------------------\n\n";
                          }
                          if( StrictCheckIVsNat(d,e,pout) )
                          {
                                out += "Non-event D/P or GBA\n--------------------------------------------------------------\n";

                                //cout<<"Non-Event D/P or GBA";
                                //cout<<"\n\n--------------------------------------------------------------\n\n";
                          }
                          if( StrictCheckIVsNat(c,e,pout) )
                          {
                                  out += "Normal GBA\n--------------------------------------------------------------\n";

                                  //cout<<"Normal GBA";
                                  //cout<<"\n\n--------------------------------------------------------------\n\n";
                          }

                          if( StrictCheckIVsNat(d,f,pout) )
                          {
                                out += "Rare GBA\n--------------------------------------------------------------\n";

                                //cout<<"Rare GBA";
                                //cout<<"\n\n--------------------------------------------------------------\n\n";
                          }
                          if( StrictCheckIVsNat(e,f,pout) )
                          {
                                out += "Ultra Rare GBA\n--------------------------------------------------------------\n";

                                //cout<<"Ultra Rare GBA";
                                //cout<<"\n\n--------------------------------------------------------------\n\n";
                         }
            }
            else
            {
                        if(CheckIVsNat(c,d,pout))
                         {
                                out += "Normal D/P or GBA\n--------------------------------------------------------------\n";

                                //cout<<"Normal D/P or GBA\n";
                                // cout<<"\n\n--------------------------------------------------------------\n\n";
                         }
                         if(CheckIVsNat(d,e,pout))
                         {
                                out += "Non-event D/P or GBA\n--------------------------------------------------------------\n";

                                //cout<<"Non-Event D/P or GBA";
                                //cout<<"\n\n--------------------------------------------------------------\n\n";
                         }
                         if(StrictCheckIVsNat(c,e,pout))
                          {
                                  out += "Normal GBA\n--------------------------------------------------------------\n";

                                  //cout<<"Normal GBA";
                                  // cout<<"\n\n--------------------------------------------------------------\n\n";
                          }
                         if(CheckIVsNat(d,f,pout))
                         {
                                out += "Rare GBA\n--------------------------------------------------------------\n";

                                //cout<<"Rare GBA";
                                //cout<<"\n\n--------------------------------------------------------------\n\n";
                         }
                         if(CheckIVsNat(e,f,pout))
                         {
                                out += "Ultra Rare GBA\n--------------------------------------------------------------\n";

                                //cout<<"Ultra Rare GBA";
                                //cout<<"\n\n--------------------------------------------------------------\n\n";
                         }
          }
                }
        }
    return out;
}

bool ShinyPid::StrictCheckIVsNat(int iv1,int iv2, QString* outp)
{
        QString nats[25]={"Hardy","Lonely","Brave","Adamant","Naughty","Bold","Docile","Relaxed","Impish","Lax","Timid","Hasty","Serious","Jolly","Naive","Modest","Mild","Quiet","Bashful","Rash","Calm","Gentle","Sassy","Careful","Quirky"};
        QString hptype[16]={ "Fighting", "Flying", "Poison", "Ground", "Rock", "Bug", "Ghost", "Steel", "Fire", "Water", "Grass", "Electric", "Psychic", "Ice", "Dragon", "Dark" };
        this->ivs[0]=iv1&0x1f;
        this->ivs[1]=(iv1&0x3e0)>>5;
        this->ivs[2]=(iv1&0x7c00)>>10;
        this->ivs[3]=iv2&0x1f;
        this->ivs[4]=(iv2&0x3e0)>>5;
        this->ivs[5]=(iv2&0x7c00)>>10;

        if((ivs[0]==in[0])&&(ivs[1]==in[1])&&(ivs[2]==in[2])&&(ivs[3]==in[3])&&(ivs[4]==in[4])&&(ivs[5]==in[5])&&(((this->pid)%25==in[6])||in[6]==25)&&(this->numFound <this->Limit||this->Limit==0))
        {
                this->numFound+=1;
                *outp += "--------------------------------------------------------------\n";
                *outp += QString::number( this->numFound ) + ") " + QString::number( this->pid ) + "\n";
                *outp += "Nature : " + nats[ ((this->pid)%25) ] + "\n" ;
                *outp += "IVs (SpD last) : " + QString::number( ivs[0] ) + " / " + QString::number( ivs[1] ) + " / " + QString::number( ivs[2] ) + " / " + QString::number( ivs[3] ) + " / " + QString::number( ivs[4] ) + " / " + QString::number( ivs[5] ) + "\n";
                *outp += "Ability : " + QString::number(2-((this->pid)%2)) + "\n" ;
                *outp += "Gender Value : " + QString::number(((this->pid)%256)) + "\n" ;
                *outp += "Hidden Power : " + hptype[ this->HPType() ] + " - " + QString::number( this->HPPower() ) + "\n" ;

                /* cout<<"\n\n--------------------------------------------------------------\n\n";
                cout<<this->numFound<<") "<<this->pid<<endl;
                cout<<"IVs/Nature: "<<ivs[0]<<"/"<<ivs[1]<<"/"<<ivs[2]<<"/"<<ivs[3]<<"/"<<ivs[4]<<"/"<<ivs[5]<<"/"<<nats[this->pid%25]<<endl;
                cout<<"Ability : "<<2-((this->pid)%2)<<endl;
                cout<<"Gender Value: "<<this->pid%256<<endl;
                cout<<"Hidden Power: "<<hptype[this->HPType()]<<"-"<<this->HPPower()<<endl; */
                return true;
        }
        return false;
}

bool ShinyPid::CheckIVsNat(int iv1,int iv2,QString* outp)
{
        QString nats[25]={"Hardy","Lonely","Brave","Adamant","Naughty","Bold","Docile","Relaxed","Impish","Lax","Timid","Hasty","Serious","Jolly","Naive","Modest","Mild","Quiet","Bashful","Rash","Calm","Gentle","Sassy","Careful","Quirky"};
        QString hptype[16]={ "Fighting", "Flying", "Poison", "Ground", "Rock", "Bug", "Ghost", "Steel", "Fire", "Water", "Grass", "Electric", "Psychic", "Ice", "Dragon", "Dark" };
        this->ivs[0]=iv1&0x1f;
        this->ivs[1]=(iv1&0x3e0)>>5;
        this->ivs[2]=(iv1&0x7c00)>>10;
        this->ivs[3]=iv2&0x1f;
        this->ivs[4]=(iv2&0x3e0)>>5;
        this->ivs[5]=(iv2&0x7c00)>>10;

        if((ivs[0]>=in[0])&&(ivs[1]>=in[1])&&(ivs[2]>=in[2])&&(ivs[3]>=in[3])&&(ivs[4]>=in[4])&&(ivs[5]>=in[5])&&(((this->pid)%25==in[6])||in[6]==25)&&(this->numFound <this->Limit||this->Limit==0))
        {
                this->numFound+=1;
                *outp += "--------------------------------------------------------------\n";
                *outp += QString::number( this->numFound ) + ") " + QString::number( this->pid ) + "\n";
                *outp += "Nature : " + nats[ ((this->pid)%25) ] + "\n" ;
                *outp += "IVs (SpD last) : " + QString::number( ivs[0] ) + " / " + QString::number( ivs[1] ) + " / " + QString::number( ivs[2] ) + " / " + QString::number( ivs[3] ) + " / " + QString::number( ivs[4] ) + " / " + QString::number( ivs[5] ) + "\n";
                *outp += "Ability : " + QString::number(2-((this->pid)%2)) + "\n" ;
                *outp += "Gender Value : " + QString::number(((this->pid)%256)) + "\n" ;
                *outp += "Hidden Power : " + hptype[ this->HPType() ] + " - " + QString::number( this->HPPower() ) + "\n" ;

                /* cout<<"\n\n--------------------------------------------------------------\n\n";
                cout<<this->numFound<<") "<<this->pid<<endl;
                cout<<"IVs/Nature: "<<ivs[0]<<"/"<<ivs[1]<<"/"<<ivs[2]<<"/"<<ivs[3]<<"/"<<ivs[4]<<"/"<<ivs[5]<<"/"<<nats[this->pid%25]<<endl;
                cout<<"Ability : "<<2-((this->pid)%2)<<endl;
                cout<<"Gender Value: "<<this->pid%256<<endl;
                cout<<"Hidden Power: "<<hptype[this->HPType()]<<"-"<<this->HPPower()<<endl; */
                return true;
        }
        return false;
}

int ShinyPid::HPPower()
{
     int num = 0;
     for (int i = 0; i < 6; i++)
     {
         if ((this->ivs[i] % 4) > 1)
         {
             num += (int) pow(2.0, (double) i);
         }
     }
     return (((num * 40) / 0x3f) + 30);


}
int ShinyPid::HPType()
{
 int num = 0;
            for (int i = 0; i < 6; i++)
            {
                if ((this->ivs[i] % 2) == 1)
                {
                    num += (int) pow(2.0, i);
                }
            }
            return ((num * 15) / 0x3f);
}

QString ShinyPid::GetChainedPid(unsigned short int nature, unsigned short int sid, unsigned short int tid, unsigned int hp, unsigned int att, unsigned int def, unsigned int spe, unsigned int spa, unsigned int spd, QProgressBar* prog)
{
    QString output = "";

        QString nats[25]={"Hardy","Lonely","Brave","Adamant","Naughty","Bold","Docile","Relaxed","Impish","Lax","Timid","Hasty","Serious","Jolly","Naive","Modest","Mild","Quiet","Bashful","Rash","Calm","Gentle","Sassy","Careful","Quirky"};
        QString hptype[16]={ "Fighting", "Flying", "Poison", "Ground", "Rock", "Bug", "Ghost", "Steel", "Fire", "Water", "Grass", "Electric", "Psychic", "Ice", "Dragon", "Dark" };
        this->numFound=0;

        this->in[0] = hp;
        this->in[1] = att;
        this->in[2] = def;
        this->in[3] = spe;
        this->in[4] = spa;
        this->in[5] = spd;
        this->in[6] = nature;
        this->ids[0] = sid;
        this->ids[1] = tid;

        //GetData();
        Prng rand;
        unsigned int iv=(this->in[0]+(this->in[1]<<5)+(this->in[2]<<10)+(this->in[3]<<15)+(this->in[4]<<20)+(this->in[5]<<25))&0x7fffffff;
        int iv1=(int)(((iv)&0xffff)%0x8000);
        int iv2=(int)((iv)>>0xf);
    unsigned int num = iv1 << 0x10;
                for (unsigned int j = 0; j < 0x10000; j++)
                {
                        unsigned int num4 =  num + j;
            rand.SetSeed(num4);
            if (((rand.Next() >> 0x10) & 0x7fff) == iv2)
            {
                                for (int k = 0; k < 0x10; k++)
                {
                                        rand.SetPrev();
                }
                this->pid = this->ShinyPID(rand);
                if(((this->pid)%25==in[6])||in[6]==25)
                {
                                 (this->numFound)+=1;

                                 output += QString::number( numFound ) + ") Chain Shiny PID: " + QString::number( this->pid ) + "\n";
                                 output += "Nature : " + nats[ ((this->pid)%25) ] + "\n" ;
                                 output += "Ability : " + QString::number(2-((this->pid)%2)) + "\n" ;
                                 output += "Gender Value : " + QString::number(((this->pid)%256)) + "\n" ;
                                 output += "Hidden Power : " + hptype[ this->HPType() ] + " - " + QString::number( this->HPPower() ) + "\n" ;
                                 output += "--------------------------------------------------------------\n";

                                 /* cout<<numFound<<") Chain Shiny PID: "<<this->pid<<endl;
                                 cout<<"Nature :"<<nats[(this->pid%25)]<<endl;
                                 cout<<"Ability : "<<2-((this->pid)%2)<<endl;
                                 cout<<"Gender Value: "<<this->pid%256<<endl;
                                 cout<<"Hidden Power: "<<hptype[this->HPTypeC()]<<"-"<<this->HPPowerC()<<endl;
                                 cout<<"\n\n--------------------------------------------------------------\n\n"; */
              }
                        }
            prog->setValue( prog->value()+1 );
        }
        if((this->numFound==0))
        {
            output = "Sorry, could not find a PID for your input";

                /* cout<<"\n\n--------------------------------------------------------------\n\n";
                cout<<"Sorry, cound not find a PID for your input.";
                cout<<"\n\n--------------------------------------------------------------\n\n"; */
        }
        return output;

}

unsigned int ShinyPid::ShinyPID(Prng rand)
{
        unsigned int num = ((this->ids[0] )^ (this->ids[1])) >> 3;
    unsigned int  num2 = (rand.SNext()>>0x10) & 7;
    unsigned int  num3 = (rand.SNext()>>0x10) & 7;
    for (int i = 0; i < 13; i++)
    {
                if ((num & (1 << i)) != 0)
        {

                        if (((rand.SNext()>>0x10) & 1) != 0)
            {
                                num2 |= 1 << (i + 3);
            }
            else
            {
                num3 |= 1 << (i + 3);
            }
       }
       else if (((rand.SNext()>>0x10) & 1) != 0)
       {
                   num2 |= 1 << (i + 3);
           num3 |= 1 << (i + 3);
       }
   }
   return ((num3 << 0x10) | num2);
}
