#ifndef SHINYPID_H
#define SHINYPID_H

#include "Prng.h"
#include <QtGui>


class ShinyPid
{
public:
        ShinyPid(void);
        QString GetPidIVs(unsigned short int nature, unsigned short int sid, unsigned short int tid, unsigned int hp, unsigned int att, unsigned int def, unsigned int spe, unsigned int spa, unsigned int spd, bool strict, int limit, QProgressBar* prog);
        QString GetChainedPid(unsigned short int nature, unsigned short int sid, unsigned short int tid, unsigned int hp, unsigned int att, unsigned int def, unsigned int spe, unsigned int spa, unsigned int spd, QProgressBar* prog);

private:

    bool Strict;
    int Limit;
        int low,high;
        unsigned int pid;
        QString In[7];
        int in[7];
        int ivs[6];
        bool inv[7];
        int ids[2];
        QString InIds[2];
        bool idv[2];
        int numFound;

        bool CheckIVsNat(int iv1,int iv2,QString* out);
        bool StrictCheckIVsNat(int iv1,int iv2,QString* out);
        QString PidIVs(int high, int low);
        unsigned int ShinyPID(Prng rand);
        //void GetData();
        void GetTid();
        void GetSid();
        void GetHp();
        void GetAt();
        void GetDf();
        void GetSpd();
        void GetSat();
        void GetSdf();
        void GetNat();
        void ValidateInput(int i);
        void ValidateId(int i);
        int HPType();
        int HPPower();
        int HPTypeC();
        int HPPowerC();


};


#endif // SHINYPID_H

